Subject: Re: NNCP with SP via high-latency links and TCP timeouts

From: John Goerzen <[email-masked]>
Date: Sat, 18 Jan 2025 19:45:07 -0600

On Sat, Jan 18 2025, Marek Küthe wrote:

> Thanks for the quick reply!
>
> On Sat, 18 Jan 2025 23:38:20 +0300
> Sergey Matveev <[email-masked]> wrote:
>
>> Well, 30sec latency is anomalously huge delay for IP-link. Even
>> communication with geostationary satellite has less than 1s RTT.
>> I can imagine only very buffer-bloated stack, that adds such huge
>> latencies.
>
> The latency occurred when I used IP via Meshtastic. Meshtastic itself
> uses LoRa (by default in long-fast mode).

I would like to learn more about this.  I have dabbled in both LoRa and
Meshtastic.  I haven't tunneled IP over Meshtastic though.

Due to LoRa's very slow bitrate, the overhead for IP packets is
significant and TCP performs quite poorly over it.  See some comments in
my project at https://github.com/jgoerzen/lorapipe about this.

But since you can specify a command to pipe to for the addrs in
nncp.hjson, you can pipe directly over a reliable transport without
involving TCP/IP.  This would have a significant benefot for LoRa.

- John